# Data Provider

## Dev Setup

1. Start the database docker service in `tools/db`.
2. Install [OCCMD](https://gitlab.opencode.de/opencode-analyzer/occmd-public.git) and edit the
   script `resources/scripts/occmd.sh` to point at the installation directory
3. Set the necessary environment variables (the following shows examples):

```
# Access token for OpenCoDE
OC_GL_APIKEY=XXX

# Directories in which temporary data is stored
GIT_CLONE_TARGET_DIRECTORY=/tmp/opencode
TOOL_RESULTS_TARGET_DIRECTORY=/tmp/opencode/toolresults

# This sets the API key needed to acess this server's API
# Length of the key needs to be > 30 characters
API_KEY=XXX

# The port on which the spring boot server is started
PORT=XXX

# Access data for the database
DB_URL=jdbc:postgresql://localhost:5432/dataprovider
DB_USER=sa
DB_PW=password
```

Make sure that the db settings match the values in the database dockerfile!
If you are using IntelliJ for development it is easiest to create a `.env` file in the `resources` folder.
This file is automatically loaded by the IDE.

## Tests

To run the e2e tests make sure to install the git submodules in the test directory.